#ifndef LIBMBTK_WIDGET_COMMON_H
#define LIBMBTK_WIDGET_COMMON_H

/* Common frame: fallback draw for widgets that are dranw as a box */
int mbtk_comm_frame_fallback_minsize(mbtk_widget_t *w, long *mx, long *my);
void mbtk_comm_frame_fallback_draw(mbtk_widget_t *w);
void mbtk_comm_frame_fallback_draw_overlay(mbtk_widget_t *w);


/* embed1: helpers for widgets that embed a single child widget; parent widget
   is turned into a hbox. */
mbtk_widget_t *mbtk_comm_embed1_set_child(mbtk_widget_t *parent, mbtk_widget_t *w);

/* embed: helpers for widgets that embed a subtree widget; the whole subtree
   is created on host widget creation time, using dummy widgets (empty boxes).
   Later replace() is used to replace the dummies with the app supplied
   widgets. */
mbtk_widget_t *mbtk_comm_embed_replace(mbtk_widget_t *host, mbtk_widget_t *old, mbtk_widget_t *new);

#endif
