#ifndef LIBMBTK_HANDLER_HOVRADIO_H
#define LIBMBTK_HANDLER_HOVRADIO_H

#include <libmbtk/src_3rd/genvector/vtp0.h>
#include <libmbtk/widget/hand_radio.h>
#include <libmbtk/handler.h>

/* The API is the same as hand_radio's */

typedef struct mbtk_handler_radio_s mbtk_handler_hovradio_t;

mbtk_handler_hovradio_t *mbtk_handler_hovradio_alloc(mbtk_window_t *parent);
void mbtk_handler_hovradio_init(mbtk_window_t *parent, mbtk_handler_hovradio_t *hr);
void mbtk_handler_hovradio_free(mbtk_handler_hovradio_t *hr);
void mbtk_handler_hovradio_uninit(mbtk_handler_hovradio_t *hr);
void mbtk_handler_hovradio_add_widget(mbtk_handler_hovradio_t *hr, mbtk_widget_t *w);
void mbtk_handler_hovradio_del_widget(mbtk_handler_hovradio_t *hr, mbtk_widget_t *w);

void mbtk_hand_hovradio_activated(mbtk_widget_t *widget);

#endif
