#ifndef LIBMBTK_WIDGET_SEPARATOR_H
#define LIBMBTK_WIDGET_SEPARATOR_H

#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>

/* a horizontal or vertical "line" to separate parts of an area */
typedef struct mbtk_separator_s {
	mbtk_widget_t w;
	unsigned int horiz:1;
} mbtk_separator_t;

mbtk_separator_t *mbtk_separator_new(mbtk_separator_t *caller_alloced, int horiz);
mbtk_separator_t *mbtk_hsep_new(mbtk_separator_t *caller_alloced);
mbtk_separator_t *mbtk_vsep_new(mbtk_separator_t *caller_alloced);

MBTK_WIDGET_INLINES(separator)

#endif
